【LeetCode从零单刷】Perfect Squares

来源:互联网 发布:啊哈算法 pdf 完整版 编辑:程序博客网 时间:2024/06/07 18:14

题目:

Given a positive integer n, find the least number of perfect square numbers (for example,1, 4, 9, 16, ...) which sum to n.

For example, given n = 12, return 3 because12 = 4 + 4 + 4; given n = 13, return 2 because13 = 4 + 9.

解答:

想一想,当 n = 13 时答案其实是 n = 9 时答案 + 1 的和;n = 12 时答案其实是 n = 8 时答案+ 1 的和,n = 8 时答案其实是 n = 4 时答案 + 1 的和。

这样,就是明显的动态规划了。当 n = i * i 时,返回值为 1;其余情况下,n 依次减去一个小于自身的平方数后求返回值,取所有返回值中最小值再 + 1。

class Solution {public:    int numSquares(int n) {        int max = 1;        while ((max + 1) * (max + 1) <= n)   max++;                int* dp = new int[n + 1];        for(int i = 1; i <= max; i++)   dp[i * i] = 1;                int tmp;        for(int i = 1; i < max; i++) {            for(int j = i * i + 1; j < (i+1)*(i+1); j++) {                int min = n;                for(int k = i; k >= 1; k--) {                    min = min > (1 + dp[j - k*k]) ? (1 + dp[j - k*k]) : min;                }                dp[j] = min;            }        }                for(int j = max * max + 1; j <= n; j++) {            int min = n;            for(int k = max; k >= 1; k--) {                min = min > (1 + dp[j - k*k]) ? (1 + dp[j - k*k]) : min;            }            dp[j] = min;        }                return dp[n];    }};

但其实,这道题拥有解析解:

根据 Lagrange's four-square theorem,自然数被最少的平方数组合的可能解只会是 1,2,3,4 其中之一。

解 = 1 比较易懂,开方即可;解 = 2, 3, 4 就要依靠 Legendre's three-square theorem 来判断了。

class Solution {  private:      int is_square(int n)    {          int sqrt_n = (int)(sqrt(n));          return (sqrt_n*sqrt_n == n);      }public:    // Based on Lagrange's Four Square theorem, there     // are only 4 possible results: 1, 2, 3, 4.    int numSquares(int n)     {          // If n is a perfect square, return 1.        if(is_square(n))         {            return 1;          }        // The result is 4 if n can be written in the         // form of 4^k*(8*m + 7). Please refer to         // Legendre's three-square theorem.        while (n%4 == 0) // n%4 == 0              n >>= 2;          if (n%8 == 7) // n%8 == 7            return 4;        // Check whether 2 is the result.        int sqrt_n = (int)(sqrt(n));         for(int i = 1; i <= sqrt_n; i++)        {              if (is_square(n - i*i))             {                return 2;              }        }          return 3;      }  }; 

0 0